import { CreateDtsFlags, CreateOptions, PlainObj, ExportFlags } from './';
import ts from 'typescript';
import * as dom from './dom';
export interface Declaration {
    import: dom.Import[];
    export: dom.TopLevelDeclaration[];
    fragment: dom.NamespaceMember[];
}
export interface ImportCacheElement {
    default?: string;
    list: Array<{
        name: string;
        as?: string;
    }>;
    from: string;
    realPath: string;
}
export interface Env {
    file: string;
    dist: string;
    uniqId: number;
    flags: CreateDtsFlags;
    program: ts.Program;
    checker: ts.TypeChecker;
    sourceFile: ts.SourceFile;
    declaration: Declaration;
    importCache: {
        [key: string]: ImportCacheElement;
    };
    declareCache: Array<{
        node: ts.Declaration;
        name: string;
    }>;
    publicNames: PlainObj<number>;
    exportDefaultName?: string;
    exportNamespace?: dom.NamespaceDeclaration;
    interfaceList: dom.InterfaceDeclaration[];
    deps: {
        [key: string]: {
            env: Env;
            namespace: dom.NamespaceDeclaration;
        };
    };
    ambientModNames: string[];
    exportFlags: ExportFlags;
    toString: () => string;
    write: () => string;
}
export declare let env: Env;
export declare function getTopEnv(): Env;
export declare function getEnv(file: string): Env;
export declare function createEnv(file: string, options?: CreateOptions): void;
export declare function popEnv(): Env;
//# sourceMappingURL=env.d.ts.map